import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class fillamentRect extends PApplet {



float     L = 400.0f;
float delta = 20.0f;
float theta = 0.0f;
float gamma = 10.0f;

public void setup()
{
    size(512, 512);
    fill(255, 255, 255, 0);
    strokeWeight(1.5f);
    stroke(0,0,0);
    rectMode(CENTER);
    println(PFont.list());
}

public void draw()
{
    float tantheta = tan(theta);
    float rotwidth = delta * sqrt(1.0f + sq(tantheta));
    
    background(255);
    translate(256, 256);
    rect(0, 0, delta, L);
    line(-delta/2, gamma, delta/2, gamma);
    line(-delta/2, -gamma, delta/2, -gamma);
    pushMatrix();
    translate(0, gamma);
    translate(-delta/2.0f, 0);
    rotate(-theta);
    stroke(0xff3380FF);
    rect(rotwidth/2, 0, rotwidth, L);
    stroke(0, 0, 0);
    popMatrix();
    theta += radians(0.05f);
    
    if ( delta*tantheta > 2*gamma )
    {
        theta = 0.0f;
    }
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "fillamentRect" });
  }
}
