

float     L = 400.0;
float delta = 20.0;
float theta = 0.0;
float gamma = 10.0;

void setup()
{
    size(512, 512);
    fill(255, 255, 255, 0);
    strokeWeight(1.5);
    stroke(0,0,0);
    rectMode(CENTER);
    println(PFont.list());
}

void draw()
{
    float tantheta = tan(theta);
    float rotwidth = delta * sqrt(1.0 + sq(tantheta));
    
    background(255);
    translate(256, 256);
    rect(0, 0, delta, L);
    line(-delta/2, gamma, delta/2, gamma);
    line(-delta/2, -gamma, delta/2, -gamma);
    pushMatrix();
    translate(0, gamma);
    translate(-delta/2.0, 0);
    rotate(-theta);
    stroke(#3380FF);
    rect(rotwidth/2, 0, rotwidth, L);
    stroke(0, 0, 0);
    popMatrix();
    theta += radians(0.05);
    
    if ( delta*tantheta > 2*gamma )
    {
        theta = 0.0;
    }
}

